#IFNDEF __FB_UNIX__
  '#DEFINE dSINGLE
  #LIBPATH "C:\opt\Gtk\lib"
#ELSE
  #DEFINE dDOUBLE
#ENDIF

#INCLUDE ONCE "../OpenGl_Player.bi"

STATIC SHARED AS GLfloat Ankle
STATIC SHARED AS GLfloat Pos_y
STATIC SHARED AS GLfloat Step_

' stuff to start the simulation
SUB new_sim CDECL(BYREF Ti AS guint32) STATIC
  Ankle = 0
  Pos_y = 0
  Step_ = Ti * 0.2

' set OpenGl parameters
  glPushAttrib(GL_LIGHTING_BIT)
  glLoadIdentity()

  STATIC AS GLfloat ambient(...) = { 0.329412, 0.223529, 0.027451, 1.0 }
  STATIC AS GLfloat diffuse(...) = { 0.780392, 0.568627, 0.113725, 1.0 }
  STATIC AS GLfloat position(0 TO 3) = { 3.0, 3.0, 3.0, 0.0 }
  glLightfv(GL_LIGHT0, GL_AMBIENT, @ambient(0))
  glLightfv(GL_LIGHT0, GL_DIFFUSE, @diffuse(0))
  glLightfv(GL_LIGHT0, GL_POSITION, @position(0))

  STATIC AS GLfloat specular(...) = { 0.992157, 0.941176, 0.807843, 1.0 }
  STATIC AS GLfloat shininess = 0.21794872 * 128.0
  glMaterialfv(GL_FRONT, GL_SPECULAR, @specular(0))
  glMaterialf(GL_FRONT, GL_SHININESS, shininess)

  STATIC AS GLfloat lmodel_ambient(...) = { 0.2, 0.2, 0.2, 1.0 }
  STATIC AS GLfloat local_view = 0.0
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, @lmodel_ambient(0))
  glLightModelfv(GL_LIGHT_MODEL_LOCAL_VIEWER, @local_view)

  glEnable(GL_LIGHTING)
  glEnable(GL_LIGHT0)
  glEnable(GL_DEPTH_TEST)

  glClearColor(1.0, 1.0, 1.0, 1.0)
  glClearDepth(1.0)

END SUB

' stuff to end the simulation
SUB del_sim CDECL(BYREF Ti AS guint32) STATIC
  glPopAttrib()
END SUB

' stuff GtkWidget::expose event for the OpenGL widget
SUB expos CDECL() STATIC
  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT)
  glLoadIdentity()
  glTranslatef(0.0, 0.0, -10.0) ' camera position

  glTranslatef(0.0, Pos_y, 0.0)
  glRotatef(Ankle, 1.0, 1.0, 1.0)
  gdk_gl_draw_teapot(TRUE, 1)
END SUB

' stuff for simulation loop
SUB tiout CDECL() STATIC
  STATIC AS GLfloat t

  Ankle += Step_ : WHILE Ankle >= 360.0 : Ankle -= 360.0 : WEND
  t = Ankle * G_PI / 180.0
  IF t > G_PI THEN t = 2.0 * G_PI - t
  Pos_y = 2.0 * (SIN (t) + 0.4 * SIN (3.0 * t)) - 1.0
END SUB

SUB sim_init CDECL ALIAS "sim_init"(BYVAL I AS _Interface PTR) STATIC EXPORT
  I->new_sim = @new_sim()
  I->del_sim = @del_sim()
  I->expos = @expos()
  I->keybo = NULL
  I->param = NULL
  I->tiout = @tiout()
  I->descr = "A dancing teapot"
END SUB

